
/* Chrysalide - Outil d'analyse de fichiers binaires
 * ##FILE## - traduction d'instructions ARMv7
 *
 * Copyright (C) 2014 Cyrille Bagard
 *
 *  This file is part of Chrysalide.
 *
 *  Chrysalide is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Chrysalide is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
 */


@title ADR

@encoding(t1) {

    @half 1 0 1 0 0 Rd(3) imm8(8)

    @syntax "add" <Rd> <PC> <imm32>

    @conv {

        Rd = Register(Rd)
        PC = Register(15)
        imm32 = ZeroExtend(imm8:'00', 10, 32)

    }

}

@encoding(T2) {

    @word 1 1 1 1 0 i(1) 1 0 1 0 1 0 1 1 1 1 0 imm3(3) Rd(4) imm8(8)

    @syntax "sub" <Rd> <PC> <imm32>

    @conv {

        Rd = Register(Rd)
        PC = Register(15)
        imm32 = ZeroExtend(i:imm3:imm8, 12, 32)

    }

    @rules {

        //if d IN {13,15} then UNPREDICTABLE;

    }

}

@encoding(T3) {

    @word 1 1 1 1 0 i(1) 1 0 0 0 0 0 1 1 1 1 0 imm3(3) Rd(4) imm8(8)

    @syntax "add" <Rd> <PC> <imm32>

    @conv {

        Rd = Register(Rd)
        PC = Register(15)
        imm32 = ZeroExtend(i:imm3:imm8, 12, 32)

    }

    @rules {

        //if d IN {13,15} then UNPREDICTABLE;

    }

}

@encoding(A1) {

    @word cond(4) 0 0 1 0 1 0 0 0 1 1 1 1 Rd(4) imm12(12)

    @syntax "add" <Rd> <PC> <const>

    @conv {

        Rd = Register(Rd)
        PC = Register(15)
        const = ARMExpandImm(imm12)

    }

}

@encoding(A2) {

    @word cond(4) 0 0 1 0 0 1 0 0 1 1 1 1 Rd(4) imm12(12)

    @syntax "sub" <Rd> <PC> <const>

    @conv {

        Rd = Register(Rd)
        PC = Register(15)
        const = ARMExpandImm(imm12)

    }

}
