
/* Chrysalide - Outil d'analyse de fichiers binaires
 * ##FILE## - traduction d'instructions ARMv7
 *
 * Copyright (C) 2014 Cyrille Bagard
 *
 *  This file is part of Chrysalide.
 *
 *  Chrysalide is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Chrysalide is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
 */


@title LDR (register, Thumb)

@encoding(t1) {

    @half 0 1 0 1 1 0 0 Rm(3) Rn(3) Rt(3)

    @syntax <Rgt> <access>

    @conv {

        Rgt = Register(Rt)
        Rgn = Register(Rn)
        Rgm = Register(Rm)
        access = _MakeMemoryAccess(Rgn, Rgm, 0)

    }

    @rules {

        //if CurrentInstrSet() == InstrSet_ThumbEE then SEE "Modified operation in ThumbEE";

    }

}

@encoding(T2) {

    @word 1 1 1 1 1 0 0 0 0 1 0 1 Rn(4) Rt(4) 0 0 0 0 0 0 imm2(2) Rm(4)

    @syntax "ldr.W" <Rgt>, <access>

    @conv {

        Rgt = Register(Rt)
        Rgn = Register(Rn)
        Rgm = Register(Rm)
        shift = DecodeImmShift(0, imm2)
        access = MakeShiftedMemoryAccess(Rgn, Rgm, shift, 0)

    }

    @rules {

        //if Rn == '1111' then SEE LDR (literal);
        //if m IN {13,15} then UNPREDICTABLE;
        //if t == 15 && InITBlock() && !LastInITBlock() then UNPREDICTABLE;
        if (Rt == '1111'); chk_call SetInsFlag(AIF_RETURN_POINT)

    }

}
