
/* Chrysalide - Outil d'analyse de fichiers binaires
 * gtkbufferview.h - prototypes pour l'affichage de tampons de lignes
 *
 * Copyright (C) 2010-2014 Cyrille Bagard
 *
 *  This file is part of Chrysalide.
 *
 *  OpenIDA is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  OpenIDA is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
 */


#ifndef _GTK_BUFFERVIEW_H
#define _GTK_BUFFERVIEW_H


#include <glib-object.h>
#include <gtk/gtk.h>


#include "../glibext/gcodebuffer.h"



#define GTK_TYPE_BUFFER_VIEW                  (gtk_buffer_view_get_type())
#define GTK_BUFFER_VIEW(obj)                  (G_TYPE_CHECK_INSTANCE_CAST((obj), GTK_TYPE_BUFFER_VIEW, GtkBufferView))
#define GTK_BUFFER_VIEW_CLASS(klass)          (G_TYPE_CHECK_CLASS_CAST((klass), GTK_TYPE_BUFFER_VIEW, GtkBufferViewClass))
#define GTK_IS_BUFFER_VIEW(obj)               (G_TYPE_CHECK_INSTANCE_TYPE((obj), GTK_TYPE_BUFFER_VIEW))
#define GTK_IS_BUFFER_VIEW_CLASS(klass)       (G_TYPE_CHECK_CLASS_TYPE((klass), GTK_TYPE_BUFFER_VIEW))
#define GTK_BUFFER_VIEW_GET_CLASS(obj)        (G_TYPE_INSTANCE_GET_CLASS((obj), GTK_TYPE_BUFFER_VIEW, GtkBufferViewClass))


/* Composant d'affichage de tampon de lignes (instance) */
typedef struct _GtkBufferView GtkBufferView;

/* Composant d'affichage de tampon de lignes (classe) */
typedef struct _GtkBufferViewClass GtkBufferViewClass;


/* Détermine le type du composant d'affichage de tampon de lignes. */
GType gtk_buffer_view_get_type(void);

/* Prend acte de l'association d'un tampon de lignes. */
void gtk_buffer_view_attach_buffer(GtkBufferView *, GBufferView *);

/* Fournit la vue associée au tampon de lignes courant. */
GBufferView *gtk_buffer_view_get_buffer(const GtkBufferView *);



/* ------------------------------ ANIMATION DU CURSEUR ------------------------------ */


/* Déplace le curseur à un emplacement en extrémité. */
bool gtk_buffer_view_move_caret_to(GtkBufferView *, bool, gint *);



#endif  /* _GTK_BUFFERVIEW_H */
